/* AUTOGENERATED FILE. DO NOT EDIT. */
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>
#include "cmock.h"
#include "mock_hal.h"

static const char* CMockString_XT_EXTW = "XT_EXTW";
static const char* CMockString_XT_MEMW = "XT_MEMW";
static const char* CMockString_xthal_get_ccount = "xthal_get_ccount";

typedef struct _CMOCK_XT_MEMW_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;

} CMOCK_XT_MEMW_CALL_INSTANCE;

typedef struct _CMOCK_XT_EXTW_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;

} CMOCK_XT_EXTW_CALL_INSTANCE;

typedef struct _CMOCK_xthal_get_ccount_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  uint32_t ReturnVal;

} CMOCK_xthal_get_ccount_CALL_INSTANCE;

static struct mock_halInstance
{
  char XT_MEMW_IgnoreBool;
  char XT_MEMW_CallbackBool;
  CMOCK_XT_MEMW_CALLBACK XT_MEMW_CallbackFunctionPointer;
  int XT_MEMW_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE XT_MEMW_CallInstance;
  char XT_EXTW_IgnoreBool;
  char XT_EXTW_CallbackBool;
  CMOCK_XT_EXTW_CALLBACK XT_EXTW_CallbackFunctionPointer;
  int XT_EXTW_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE XT_EXTW_CallInstance;
  char xthal_get_ccount_IgnoreBool;
  uint32_t xthal_get_ccount_FinalReturn;
  char xthal_get_ccount_CallbackBool;
  CMOCK_xthal_get_ccount_CALLBACK xthal_get_ccount_CallbackFunctionPointer;
  int xthal_get_ccount_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE xthal_get_ccount_CallInstance;
} Mock;

extern jmp_buf AbortFrame;

void mock_hal_Verify(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_MEM_INDEX_TYPE call_instance;
  call_instance = Mock.XT_MEMW_CallInstance;
  if (Mock.XT_MEMW_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_XT_MEMW);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.XT_MEMW_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.XT_EXTW_CallInstance;
  if (Mock.XT_EXTW_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_XT_EXTW);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.XT_EXTW_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.xthal_get_ccount_CallInstance;
  if (Mock.xthal_get_ccount_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_xthal_get_ccount);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.xthal_get_ccount_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
}

void mock_hal_Init(void)
{
  mock_hal_Destroy();
}

void mock_hal_Destroy(void)
{
  CMock_Guts_MemFreeAll();
  memset(&Mock, 0, sizeof(Mock));
}

void XT_MEMW(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_XT_MEMW_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_XT_MEMW);
  cmock_call_instance = (CMOCK_XT_MEMW_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.XT_MEMW_CallInstance);
  Mock.XT_MEMW_CallInstance = CMock_Guts_MemNext(Mock.XT_MEMW_CallInstance);
  if (Mock.XT_MEMW_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.XT_MEMW_CallbackBool &&
      Mock.XT_MEMW_CallbackFunctionPointer != NULL)
  {
    Mock.XT_MEMW_CallbackFunctionPointer(Mock.XT_MEMW_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (Mock.XT_MEMW_CallbackFunctionPointer != NULL)
  {
    Mock.XT_MEMW_CallbackFunctionPointer(Mock.XT_MEMW_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void XT_MEMW_CMockIgnore(void)
{
  Mock.XT_MEMW_IgnoreBool = (char)1;
}

void XT_MEMW_CMockStopIgnore(void)
{
  Mock.XT_MEMW_IgnoreBool = (char)0;
}

void XT_MEMW_CMockExpect(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_XT_MEMW_CALL_INSTANCE));
  CMOCK_XT_MEMW_CALL_INSTANCE* cmock_call_instance = (CMOCK_XT_MEMW_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.XT_MEMW_CallInstance = CMock_Guts_MemChain(Mock.XT_MEMW_CallInstance, cmock_guts_index);
  Mock.XT_MEMW_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
}

void XT_MEMW_AddCallback(CMOCK_XT_MEMW_CALLBACK Callback)
{
  Mock.XT_MEMW_IgnoreBool = (char)0;
  Mock.XT_MEMW_CallbackBool = (char)1;
  Mock.XT_MEMW_CallbackFunctionPointer = Callback;
}

void XT_MEMW_Stub(CMOCK_XT_MEMW_CALLBACK Callback)
{
  Mock.XT_MEMW_IgnoreBool = (char)0;
  Mock.XT_MEMW_CallbackBool = (char)0;
  Mock.XT_MEMW_CallbackFunctionPointer = Callback;
}

void XT_EXTW(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_XT_EXTW_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_XT_EXTW);
  cmock_call_instance = (CMOCK_XT_EXTW_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.XT_EXTW_CallInstance);
  Mock.XT_EXTW_CallInstance = CMock_Guts_MemNext(Mock.XT_EXTW_CallInstance);
  if (Mock.XT_EXTW_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.XT_EXTW_CallbackBool &&
      Mock.XT_EXTW_CallbackFunctionPointer != NULL)
  {
    Mock.XT_EXTW_CallbackFunctionPointer(Mock.XT_EXTW_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (Mock.XT_EXTW_CallbackFunctionPointer != NULL)
  {
    Mock.XT_EXTW_CallbackFunctionPointer(Mock.XT_EXTW_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void XT_EXTW_CMockIgnore(void)
{
  Mock.XT_EXTW_IgnoreBool = (char)1;
}

void XT_EXTW_CMockStopIgnore(void)
{
  Mock.XT_EXTW_IgnoreBool = (char)0;
}

void XT_EXTW_CMockExpect(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_XT_EXTW_CALL_INSTANCE));
  CMOCK_XT_EXTW_CALL_INSTANCE* cmock_call_instance = (CMOCK_XT_EXTW_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.XT_EXTW_CallInstance = CMock_Guts_MemChain(Mock.XT_EXTW_CallInstance, cmock_guts_index);
  Mock.XT_EXTW_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
}

void XT_EXTW_AddCallback(CMOCK_XT_EXTW_CALLBACK Callback)
{
  Mock.XT_EXTW_IgnoreBool = (char)0;
  Mock.XT_EXTW_CallbackBool = (char)1;
  Mock.XT_EXTW_CallbackFunctionPointer = Callback;
}

void XT_EXTW_Stub(CMOCK_XT_EXTW_CALLBACK Callback)
{
  Mock.XT_EXTW_IgnoreBool = (char)0;
  Mock.XT_EXTW_CallbackBool = (char)0;
  Mock.XT_EXTW_CallbackFunctionPointer = Callback;
}

uint32_t xthal_get_ccount(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_xthal_get_ccount_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_xthal_get_ccount);
  cmock_call_instance = (CMOCK_xthal_get_ccount_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.xthal_get_ccount_CallInstance);
  Mock.xthal_get_ccount_CallInstance = CMock_Guts_MemNext(Mock.xthal_get_ccount_CallInstance);
  if (Mock.xthal_get_ccount_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    if (cmock_call_instance == NULL)
      return Mock.xthal_get_ccount_FinalReturn;
    Mock.xthal_get_ccount_FinalReturn = cmock_call_instance->ReturnVal;
    return cmock_call_instance->ReturnVal;
  }
  if (!Mock.xthal_get_ccount_CallbackBool &&
      Mock.xthal_get_ccount_CallbackFunctionPointer != NULL)
  {
    uint32_t cmock_cb_ret = Mock.xthal_get_ccount_CallbackFunctionPointer(Mock.xthal_get_ccount_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return cmock_cb_ret;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (Mock.xthal_get_ccount_CallbackFunctionPointer != NULL)
  {
    cmock_call_instance->ReturnVal = Mock.xthal_get_ccount_CallbackFunctionPointer(Mock.xthal_get_ccount_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
  return cmock_call_instance->ReturnVal;
}

void xthal_get_ccount_CMockIgnoreAndReturn(UNITY_LINE_TYPE cmock_line, uint32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xthal_get_ccount_CALL_INSTANCE));
  CMOCK_xthal_get_ccount_CALL_INSTANCE* cmock_call_instance = (CMOCK_xthal_get_ccount_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xthal_get_ccount_CallInstance = CMock_Guts_MemChain(Mock.xthal_get_ccount_CallInstance, cmock_guts_index);
  Mock.xthal_get_ccount_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
  Mock.xthal_get_ccount_IgnoreBool = (char)1;
}

void xthal_get_ccount_CMockStopIgnore(void)
{
  if(Mock.xthal_get_ccount_IgnoreBool)
    Mock.xthal_get_ccount_CallInstance = CMock_Guts_MemNext(Mock.xthal_get_ccount_CallInstance);
  Mock.xthal_get_ccount_IgnoreBool = (char)0;
}

void xthal_get_ccount_CMockExpectAndReturn(UNITY_LINE_TYPE cmock_line, uint32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xthal_get_ccount_CALL_INSTANCE));
  CMOCK_xthal_get_ccount_CALL_INSTANCE* cmock_call_instance = (CMOCK_xthal_get_ccount_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xthal_get_ccount_CallInstance = CMock_Guts_MemChain(Mock.xthal_get_ccount_CallInstance, cmock_guts_index);
  Mock.xthal_get_ccount_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
}

void xthal_get_ccount_AddCallback(CMOCK_xthal_get_ccount_CALLBACK Callback)
{
  Mock.xthal_get_ccount_IgnoreBool = (char)0;
  Mock.xthal_get_ccount_CallbackBool = (char)1;
  Mock.xthal_get_ccount_CallbackFunctionPointer = Callback;
}

void xthal_get_ccount_Stub(CMOCK_xthal_get_ccount_CALLBACK Callback)
{
  Mock.xthal_get_ccount_IgnoreBool = (char)0;
  Mock.xthal_get_ccount_CallbackBool = (char)0;
  Mock.xthal_get_ccount_CallbackFunctionPointer = Callback;
}

